/*
SETUP NEW GM CHAPTERS
This script pretends save time in the process setup new CHAPTER.

	STEP 1 : Rename files inside the folders
	STEP 2 : Edit the XML text
	STEP 3 : Duplicate JPG borders
	STEP 4 : Duplicate Timeline
	STEP 5 : Duplicate Selection Chapter Card

*/



// *** DOUBLE CLICK TO EXECUTE THE SCRIPT IN WINDOWS ***/

//////////////////////////////////////

// DEFINE THE ROOT OF THE GIT REPOSITORY
var git_root = "C:\\King\\BW3_git";


// NEW ID DEFINITION : 
var CH_arr = [17,18,19,20];


var STEP1 = true;
var STEP2 = true;
var STEP3 = true;
var STEP4 = true;
var STEP5 = true;

////////////////////////////////////






for( var i=0; i<CH_arr.length; i++){	setup_new_GM_chapter( CH_arr[i] )	}

WScript.Echo("------ SCRIPT ENDS ------");
WScript.Echo("------ CONFIRMATION ------");







function setup_new_GM_chapter( CH ){


		/////////////////////////////////////////////////  VARIABLES

		var ch_string = zeroFill(CH,2);
		var id_string = zeroFill(CH,3);

		var git_res = git_root + "\\client\\game\\res\\common\\scenes\\saga_map\\";



		var sFolderName, sFileName, sStringToFind, sStringToReplace, ch_gm_folder, id_bg_folder;

		/////////////////////////////////////////////////  MAIN CODE

		// STEP 1 : Duplicate files and Rename => IT WORKS!!!

		if( STEP1==true )
		{
			// Duplicate sagamap_chapter_ChN.xml, and replace ChN with ch_string
			sFileName = "sagamap_chapter_" + ch_string + ".xml";

			copy_file( CH+" STEP1", git_res + "sagamap_chapter_ChN.xml",	git_res + sFileName );
		}
			
		// STEP 2 : Edit the XML scenes text. Subs NNN with ID => IT WORKS!!!

		if( STEP2==true )
		{
			WScript.echo( CH + " ==> STEP2" );

			// 3.1) Edit the XML scenes 

			// function edit_document( git_res, ch_xml_file, new_CH, new_C, new_ID )
			edit_document( git_res, git_res + sFileName,
				null, null, id_string
			);
		}
			

		// STEP 3 : Duplicate SM .jpg captures

		if( STEP3==true )
		{
			WScript.echo( CH + " ==> STEP3" );

			var git_tex = git_root + "\\client\\game\\res\\common\\tex\\saga_map\\chapter_borders\\";	

			// There is one file: chapter_ChN_bg_border.jpg
			sFileName = git_tex + "chapter_" + ch_string + "_bg_border.jpg";

			copy_file( CH+" STEP3", git_tex+"chapter_ChN_bg_border.jpg",	sFileName );
		}

		// STEP 4 : Duplicate Timelines

		if( STEP4==true )
		{
			WScript.echo( CH + " ==> STEP4" );

			var git_tl = git_root + "\\client\\game\\res\\common\\timelines\\";	

			// There is one file: idNNNsm_timeline.xml
			sFileName = git_tl + "id" + id_string + "sm_timeline.xml";

			copy_file( CH+" STEP4", git_tl+"idNNNsm_timeline.xml",	sFileName );
		}

		// STEP 5 : Duplicate Selection Chapter PNG

		if( STEP5==true )
		{
			WScript.echo( CH + " ==> STEP5" );

			var git_tl = git_root + "\\client\\game\\res\\common\\tex\\selection_chapter\\";	

			// There is one file: chapter_ChN.png
			sFileName = git_tl + "chapter" + ch_string + ".png";

			copy_file( CH+" STEP5", git_tl+"chapterChN.png",	sFileName );
		}
}
// END setup_new_GM_chapter






/////////////////////////////////////////////////  FUNCTIONS

/* 
FUNCTION : RENAME FILES

	sFolder: 	Folder Name
	sFile: 		File Name
	sString1: 	String to search for
	sString2: 	String to replace
	Returns: 	Number of files renamed
*/

function renameFiles(sFolder, sFile, sString1, sString2)
{
	//WScript.echo(sFolder+",   "+sFile+",   "+sString1+",   "+sString2);

	var oFSO, oFile, oFolder;
	var re, index;
	var sName;
	var i = 0, n;

	// Read the folder
	oFSO = new ActiveXObject("Scripting.FileSystemObject");
	oFolder = oFSO.GetFolder(sFolder);

	// Inside the folder...
	try
	{
		// Build an array with the files inside
		index = new Enumerator(oFolder.Files);

		for (; !index.atEnd(); index.moveNext())
		{
			// For each file inside...
			oFile = index.item();

			// get the name
			sName = oFile.Name;

			//WScript.echo("sName:"+sName+",   sFile:"+sFile);

			// LUX! If the file is 
			if( sName==sFile )
			{
				// Find the string and...
				n = sName.indexOf(sString1);

				if(n != -1)
				{
					// Try to rename!
					try
					{
						//WScript.echo( sFile+"[ "+sString1+" => "+sString2+" ]  Release Rename!!!");

						sName = sName.replace(sString1,sString2);
						oFile.Name = sName;
						i++;
					}
					catch(e)
					{
						WScript.Echo("Can not rename file " + sName + " because\n" + e.description);
					}
				}
			}
		}// End for...
	}
	catch(e)
	{
		WScript.Echo("Could not access folder " + sFolder + " because\n" + e.description);
		return 0;
	}
	finally
	{
		oFSO = null;
		re = null;
		return i;
	}
}
// END renameFiles




// FUNCTION : EDIT DOCUMENT AND REPLACE ### WITH ID
// http://www.java2s.com/Tutorial/JavaScript/0600__MS-JScript/TextStreamReadAll.htm

function edit_document(git_res, ch_xml_file, string_ch, number_ch, string_id)
{
	var fsoForReading = 1;
	var fsoForWriting = 2;
	var fsoForAppending = 8;
	var re = false;
	oFSO = null;

	var afile, tempFile, tx, n=0, alltx="";
	
	oFSO = new ActiveXObject("Scripting.FileSystemObject");
	oFSO.CreateTextFile(git_res+"TEMP.txt",true);

	tempFile = 	oFSO.OpenTextFile(git_res+"TEMP.txt", fsoForWriting, true);// Temporal file
	afile = 	oFSO.OpenTextFile(ch_xml_file, fsoForReading, false);// Edited file

	WScript.Echo("edit_document: " + ch_xml_file);

	// Read from the file and display the results.
	while (!afile.AtEndOfStream)
    {
    	tx = afile.ReadLine();
    	if(string_ch!=null)		{	tx = replaceAll(tx, "ChN", string_ch)	};
    	if(number_ch!=null)		{	tx = replaceAll(tx, "ChN", number_ch)	};
    	if(string_id!=null)		{	tx = replaceAll(tx, "NNN", string_id)	};

    	tempFile.WriteLine( tx );
  
    	n++;
    }

    afile.close();
    tempFile.close();

   	oFSO.DeleteFile( ch_xml_file );

   	try{
   		oFSO.MoveFile( git_res+"TEMP.txt", ch_xml_file );
   	}
   	catch(e)
	{
		WScript.Echo("Could not write file " + ch_xml_file + " because\n" + e.description);
		//return 0;
	}
	finally
	{
		oFSO = null;
		re = false;
		//return sName;
	}
}
// END editDocument




//////////////////////////////////////////////////////     UTILS     ////////////////////





// FUNCTION : UTIL : RENAME RECURSIVE

function replaceAll(str, find, replace) 
{
	var tx = str.replace(new RegExp(find, 'g'), replace);
	if( tx!=str ){	WScript.Echo("WriteLine: " + tx)	}

  	return tx



}




// FUNCTION : UTIL : ADD ZEROS

function zeroFill(val, zeros)//val = 7, max = 5
{
	while ((val+"").length < zeros)		val = "0" + val;

	return val// val = 00007
}



// FUNCTION : UTIL : INVERT ARRAY : UNDO!

function directionArray( arr, boo )
{
	if( boo ){		for(var i=0; i<main_arr.length; i++)
	{
		arr[i].reverse();
	}}

	return arr
}



// FUNCTION : UTIL : DUPLICATE A FILE 
// http://www.java2s.com/Tutorial/JavaScript/0600__MS-JScript/FileSystemObjectCopyFile.htm

function copy_file(origin, placeholder, new_ame)
{
	try
	{
		WScript.echo( "copy_file:\r" + placeholder + "\r" + new_ame);

		var oFSO;
			oFSO = new ActiveXObject("Scripting.FileSystemObject");
			oFSO.CopyFile (placeholder, new_ame, false);
			oFSO = null;
	}
	catch(e)
	{
		WScript.Echo(origin+": Can not DUPLICATE file because\n" + e.description);
	}
}



// FUNCTION : UTIL : DUPLICATE FOLDER 
// http://www.java2s.com/Tutorial/JavaScript/0600__MS-JScript/FileSystemObjectCopyFolder.htm

function duplicate_folder(placeholder,new_ame)
{	
	test_directory(placeholder);
	//WScript.echo( "duplicate_folder:\r"+placeholder+"\r"+new_ame);

    try
	{
		var oFSO;
			oFSO = new ActiveXObject("Scripting.FileSystemObject");
    		oFSO.CopyFolder (placeholder+"\\*", new_ame+"\\", false);
	}
	catch(e)
	{
		WScript.Echo("Can not DUPLICATE folder because\n" + e.description);
	}
}



// FUNCTION : UTIL : TEST DIRECTORY
function test_directory(directory)
{
    try
	{
		var oFSO, aFolder, date;
		 	oFSO = new ActiveXObject("Scripting.FileSystemObject");
    		aFolder = oFSO.GetFolder (directory);
    		date = aFolder.DateLastAccessed;

    		WScript.echo( "test_directory:\r"+directory+" "+date);
	}
	catch(e)
	{
		WScript.Echo("Can not find the directore because\n" + e.description);
	}
}