varying lowp vec4 v_color;
varying lowp vec2 v_texCoord;

uniform sampler2D u_texture;

uniform vec4 u_outlineSize;

void main()
{	
	lowp float outlineSize = u_outlineSize.x;
	vec4 baseColor = texture2D(u_texture, v_texCoord);
	float alpha = texture2D(u_texture, v_texCoord + vec2(-outlineSize, 0.0)).a;
	alpha += texture2D(u_texture, v_texCoord + vec2(outlineSize, 0.0)).a;
	alpha += texture2D(u_texture, v_texCoord + vec2(0.0, -outlineSize)).a;
	alpha += texture2D(u_texture, v_texCoord + vec2(0.0, outlineSize)).a;
	gl_FragColor.rgb = baseColor.rgb * baseColor.a + v_color.rgb * ( 1.0 - baseColor.a) ;
	gl_FragColor.a = baseColor.a + alpha;
}
